#
# Conditional build:
%bcond_without	doc	# API documentation
%bcond_without	tests	# unit tests

%define 	module	traitlets
Summary:	A configuration system for Python applications
Summary(pl.UTF-8):	System konfiguracji dla aplikacji w Pythonie
Name:		python3-%{module}
Version:	5.14.3
Release:	1
License:	BSD
Group:		Libraries/Python
#Source0Download: https://github.com/ipython/traitlets/releases
Source0:	https://github.com/ipython/traitlets/releases/download/v%{version}/%{module}-%{version}.tar.gz
# Source0-md5:	f6e6529cca4cbe3299e3f07ce24d3fdc
URL:		https://traitlets.readthedocs.io/en/stable/
%if %(locale -a | grep -q '^C\.utf8$'; echo $?)
BuildRequires:	glibc-localedb-all
%endif
BuildRequires:	python3-build
BuildRequires:	python3-hatchling >= 1.5
BuildRequires:	python3-installer
BuildRequires:	python3-modules >= 1:3.8
%if %{with tests}
BuildRequires:	python3-decorator
BuildRequires:	python3-ipython_genutils
BuildRequires:	python3-pytest
BuildRequires:	python3-six
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 2.044
%if %{with doc}
BuildRequires:	python3-ipython_genutils
BuildRequires:	python3-myst_parser
BuildRequires:	python3-pydata_sphinx_theme
BuildRequires:	sphinx-pdg-3
%endif
Requires:	python3-modules >= 1:3.8
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Traitlets is a framework that lets Python classes have attributes with
type checking, dynamically calculated default values, and "on change"
callbacks.

%description -l pl.UTF-8
Traitlets to szkielet pozwalający klasom Pythona na trzymanie
atrybutów ze sprawdzaniem typów, dynamicznie wyliczanymi wartościami
domyślnymi oraz wywołaniami wstecznym "przy zmianie".

%package apidocs
Summary:	API documentation for traitlets module
Summary(pl.UTF-8):	Dokumentacja API modułu traitlets
Group:		Documentation

%description apidocs
API documentation for traitlets module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu traitlets.

%prep
%setup -q -n %{module}-%{version}

%{__sed} -i -e '1s,/usr/bin/env python$,%{__python3},' \
	examples/{argcomplete_app.py,myapp.py,subcommands_app.py}

%build
%py3_build_pyproject

%if %{with tests}
%{__python3} -m pytest traitlets
%endif

%if %{with doc}
PYTHONPATH="$(pwd)" \
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT
%py3_install_pyproject

%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/traitlets/tests

install -d $RPM_BUILD_ROOT%{_examplesdir}/python3-%{module}-%{version}
cp -p examples/*.py $RPM_BUILD_ROOT%{_examplesdir}/python3-%{module}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE README.md
%{py3_sitescriptdir}/traitlets
%{py3_sitescriptdir}/traitlets-%{version}.dist-info
%{_examplesdir}/python3-%{module}-%{version}

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/build/html/{_static,*.html,*.js}
%endif
%changelog
* Sat Apr 19 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-traitlets.git;a=log;h=master

* Sat Apr 19 2025 Jan Palus <atler@pld-linux.org> f3ff70d
- more doc deps

* Tue Mar 25 2025 Jan Palus <atler@pld-linux.org> f4f4416
- up to 5.14.3

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 7496c63
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 979342d
- python 3.13 rebuild

* Sun Mar 09 2025 Jan Rękorajski <baggins@pld-linux.org> aabbb9b
- use patch -P

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 6969860
- rebuild with tests and docs

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> e51d5d3
- rebuild with python 3.10

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> fb9ee76
- release 2 (by relup.sh)

* Wed Nov 06 2019 Jakub Bogusz <qboosh@pld-linux.org> b2310e0
- updated to 4.3.3

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 17b7c71
- rebuild with python 3.8
- release 7 (by relup.sh)

* Sun Sep 22 2019 Jakub Bogusz <qboosh@pld-linux.org> b9b0f45
- py2 tests require UTF-8 locale somewhere; release 6

* Sat Sep 21 2019 Jakub Bogusz <qboosh@pld-linux.org> b36dcc9
- don't package tests; release 5

* Sat Sep 21 2019 Jakub Bogusz <qboosh@pld-linux.org> b460cd2
- cleaned up the mess
- added use-setuptools patch (use setuptools to generate pythonegg dependencies)
- release 4

* Tue Jul 03 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 24b8d77
- release 3 (by relup.sh)

* Mon Mar 27 2017 Mateusz Korniak <matkor@pld-linux.org> ffea7c6
- Release 2. R: python3-decorator.

* Mon Mar 27 2017 Mateusz Korniak <matkor@pld-linux.org> b2db72f
- Version 4.3.2. rel. 1. Initial.

